/***************************************************************************
 *   Copyright (C) 2009 - 2012 by Artem 'DOOMer' Galichkin                        *
 *   doomer3d@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIALOGUPLOADER_H
#define DIALOGUPLOADER_H

#include "uploader.h"

#include <QtGui/QDialog>

namespace Ui {
	class DialogUploader;
}

class DialogUploader : public QDialog
{
    Q_OBJECT
    
public:
    explicit DialogUploader(QWidget *parent = 0);
    ~DialogUploader();
    
protected:
    void changeEvent(QEvent *e);
    
private Q_SLOTS:
    void slotUploadStart();
    void slotSeletHost(int type);
	void slotUploadProgress(qint64 bytesSent, qint64 bytesTotal);
	void slotUploadDone();
	void slotUploadFail(const QByteArray &error);
	void slotChangeExtCode(int code);
	void slotCopyLink();
    
private:
    Ui::DialogUploader *ui;
    
    Uploader* uploader;
	QWidget* _uploaderWidget;
    
    // storage id curren selected img sho
    qint8 selectedHost;
};

#endif // DIALOGUPLOADER_H
